<!doctype html>
<html>
<head>
<meta charset="UTF-8">
<meta name="viewport" content="width=device-width, initial-scale=1">
    <title>サブネットマスク計算</title>
<meta name="keywords" content="">
<meta name="description" content="">
<meta name="robots" content="none, noarchive" />
<link rel="SHORTCUT ICON" href="./favicon.ico" /> 
<link rel="stylesheet" href="https://unpkg.com/ress/dist/ress.min.css" />
<link rel="stylesheet" href="./style.css" type="text/css" />
</head>
<body>
<div style="text-align:center;font-size:120%;width:100%; background-color:#FFDC3B; padding:0.1em;">
サブネット計算
</div>
<div class="container">
<?php
error_reporting(-1);
$script = $_SERVER['SCRIPT_NAME'];
$script = basename($script);
date_default_timezone_set('Asia/Tokyo');
$debug_mode = 0;			// 0:通常 1:デバッグモード
if ($debug_mode) {
	list($microsec,$sec) = explode(' ',microtime());
	$date = date("Y/m/d H:i:s",$sec) . preg_replace('/^0/','',$microsec);
	file_put_contents('log.log', $date . "開始-----------------------------------------------------------------------\n", FILE_APPEND | LOCK_EX);
}
$odir = str_replace('\\','/', dirname(__FILE__));				// 初期ディレクトリ

foreach ($_REQUEST as $key=>$val) {
	$req[$key] = $val;
}
if (req('reset')) {
	foreach ($req as $key=>$val) {
		$req[$key] = '';
	}
}
$html = '';
$html .= "<form action=\"$script\" method=\"post\" style=\"margin:0;\">\n";
$html .= "<div style=\"border-style:solid;border-width:0.5px;margin-top:0.5em;\">";
$html .= "<div style=\"display:flex;flex-wrap:wrap;align-items: center;justify-content:center;border-style:solid;border-width:0.5px;\"><div style=\"padding:0.5em;\"><input type=\"submit\" value=\"計算\"></div><div style=\"padding:0.5em;\"><input type=\"submit\" name=\"reset\" value=\"リセット\"></div></div>\n";
$index = "<div style=\"display:flex;flex-wrap:wrap;align-items: center;border-style:solid;border-width:0.5px;\">
<div style=\"padding:0.5em;flex-basis:9em;flex-grow:1;align-self:stretch;\">title</div>
<div style=\"padding:0.5em;flex-basis:12em;flex-grow:2;align-self:stretch;white-space:nowrap;\">cont</div>
<div style=\"flex-basis:12em;margin-left: auto;padding:0.5em;background:#eeeeee;align-self:stretch;flex-grow:4;\"><div style=\"text-align:right;vertical-align:center;\">comment</div></div>
</div>";
$ip_str = $index;
$ip_str = str_replace('title', 'IPアドレス', $ip_str);
$nmb_list = array();
for ($i=0;$i<=255;$i++) {
	$nmb_list[] = $i;
}
$ip_tmp = '';
for ($nmb=1;$nmb<=4;$nmb++) {
	if (!isset($req['ip_' . $nmb])) { $req['ip_' . $nmb] = 0; }
	$ip_tmp .= "<input type=\"text\" name=\"ip_$nmb\" value=\"" . $req['ip_' . $nmb] . "\" style=\"width:3em;font-size:120%;ime-mode:disabled;\">";
	if ($nmb < 4) { $ip_tmp .= "・"; }
}
$ip_str = str_replace('cont', $ip_tmp, $ip_str);
$ip[1] = sprintf( "%08d", decbin(intval($req['ip_1'])));
$ip[2] = sprintf( "%08d", decbin(intval($req['ip_2'])));
$ip[3] = sprintf( "%08d", decbin(intval($req['ip_3'])));
$ip[4] = sprintf( "%08d", decbin(intval($req['ip_4'])));
$ip_str = str_replace('comment', join(' ',$ip), $ip_str);
$html .= $ip_str;
$sn_str = $index;
$sn_str = str_replace('title', 'サブネットマスク', $sn_str);
$to0 = 0;
$subnet_tmp = '';
for ($nmb=1;$nmb<=4;$nmb++) {
	$subnet_tmp .= "<select name=\"snm_$nmb\" size=\"1\" style=\"font-size:120%;\">\n";
	if (isset($req['snm_' . $nmb])) {
		$snm_[$nmb] = $req['snm_' . $nmb];
	} else {
		$snm_[$nmb] = '';
	}
	if ($to0) { $snm_[$nmb] = 0; }
	foreach (array(0,128,192,224,240,248,252,254,255) as $i) {
		$selected = '';
		if (isset($snm_[$nmb]) && $snm_[$nmb] == $i) {
			$selected = ' selected="selected"';
		}
		$subnet_tmp .= "<option value=\"$i\"$selected>$i</option>\n";
	}
	$subnet_tmp .= "</select>";
	if ($nmb < 4) { $subnet_tmp .= "・"; }
	if (isset($req['snm_' . $nmb]) && $req['snm_' . $nmb] < 255) { $to0 = 1; }
}
$sn_str = str_replace('cont', $subnet_tmp, $sn_str);

$snm[1] = sprintf( "%08d", decbin(intval($snm_[1])));
$snm[2] = sprintf( "%08d", decbin(intval($snm_[2])));
$snm[3] = sprintf( "%08d", decbin(intval($snm_[3])));
$snm[4] = sprintf( "%08d", decbin(intval($snm_[4])));
for ($nmb=1;$nmb<=4;$nmb++) {
	$na[$nmb] = '';
	for ($i=0;$i<=7;$i++) {
		$na[$nmb] .= substr($ip[$nmb],$i,1) * substr($snm[$nmb],$i,1);
	}
}
$snms = $snm[1] . ' ' . $snm[2] . ' ' . $snm[3] . ' ' . $snm[4] . "";
$sn_str = str_replace('comment', $snms, $sn_str);
$html .= $sn_str;
$na_str = $index;
$na_str = str_replace('title', 'ネットワークアドレス<br />(開始アドレス)', $na_str);
$na_str = str_replace('cont', "<span style=\"font-size:120%;\">" . bindec($na[1]) . '.' . bindec($na[2]) . '.' . bindec($na[3]) . '.' . bindec($na[4]) . "</span>", $na_str);
$na_com = '';
$na_com .= "<div style=\"text-align:right;\">" . join(' ',$ip) . '</div>';
$na_com .= "<div style=\"text-align:right;\">" . join(' ',$snm) . "</div>";
$na_com .= "<div style=\"text-align:center;\">↓</div>";
$na_com .= "<div style=\"text-align:right;\">論理積　" . join(' ',$na) . "</div>";
$na_com .= "<div style=\"text-align:center;\">↓</div>";
$na_com .= "<div style=\"text-align:center;font-size:120%;\">" . bindec($na[1]) . '.' . bindec($na[2]) . '.' . bindec($na[3]) . '.' . bindec($na[4]) . "</div>";
$na_str = str_replace('comment', $na_com, $na_str);
$html .= $na_str;
for ($nmb=1;$nmb<=4;$nmb++) {
	$ba[$nmb] = '';
	$snm_r[$nmb] = '';
	for ($i=0;$i<=7;$i++) {
		if (substr($snm[$nmb],$i,1)) {
			$snm_r[$nmb] .= '0';
		} else {
			$snm_r[$nmb] .= '1';
		}
		if (substr($ip[$nmb],$i,1) || !substr($snm[$nmb],$i,1)) {
			$ba[$nmb] .= '1';
		} else {
			$ba[$nmb] .= '0';
		}
	}
}
$ba_str = $index;
$ba_str = str_replace('title', 'ブロードキャストアドレス<br />(終了アドレス)', $ba_str);
$ba_str = str_replace('cont', "<span style=\"font-size:120%;\">" . bindec($ba[1]) . '.' . bindec($ba[2]) . '.' . bindec($ba[3]) . '.' . bindec($ba[4]) . "</span>", $ba_str);
$ba_com = '';
$ba_com .= "<div style=\"text-align:right;\">" . join(' ',$ip) . '</div>';
$ba_com .= "<div style=\"text-align:center;\">サブネットマスクをビット反転</div>";
$ba_com .= "<div style=\"text-align:right;\">" . join(' ',$snm_r) . "</div>";
$ba_com .= "<div style=\"text-align:center;\">↓</div>";
$ba_com .= "<div style=\"text-align:right;\">論理和　" . join(' ',$ba) . "</div>";
$ba_com .= "<div style=\"text-align:center;\">↓</div>";
$ba_com .= "<div style=\"text-align:center;font-size:120%;\">" . bindec($ba[1]) . '.' . bindec($ba[2]) . '.' . bindec($ba[3]) . '.' . bindec($ba[4]) . "</div>";
$ba_str = str_replace('comment', $ba_com, $ba_str);
$html .= $ba_str;
$ips = 0;
if (bindec($ba[1]) - bindec($na[1])) {
	$ips += (bindec($ba[1]) - bindec($na[1])) * 256 *256 *256;
}
if (bindec($ba[2]) - bindec($na[2])) {
	$ips += (bindec($ba[2]) - bindec($na[2])) * 256 *256;
}
if (bindec($ba[3]) - bindec($na[3])) {
	$ips += (bindec($ba[3]) - bindec($na[3])) * 256;
}
if (bindec($ba[4]) - bindec($na[4])) {
	$ips += (bindec($ba[4]) - bindec($na[4]));
}
$ips++;
$ip_nmb_str = $index;
$ip_nmb_str = str_replace('title', 'IPアドレスの数', $ip_nmb_str);
$ip_nmb_str = str_replace('cont', "<span style=\"font-size:120%\">" . number_format($ips) . "個</span>", $ip_nmb_str);
$ip_nmb_str = preg_replace('|<div[^>]+><div[^>]+>comment</div></div>|', '', $ip_nmb_str);
//$ip_nmb_str = str_replace('comment', '', $ip_nmb_str);
$html .= $ip_nmb_str;
$ha_str = $index;
$ha_str = str_replace('title', 'ホストアドレス<br />(利用できるIPアドレス)', $ha_str);
$from = bindec($na[1]) . '.' . bindec($na[2]) . '.' . bindec($na[3]) . '.' . (bindec($na[4]) + 1);
$to = bindec($ba[1]) . '.' . bindec($ba[2]) . '.' . bindec($ba[3]) . '.' . (bindec($ba[4]) - 1);
if (bindec($na[4]) + 1 <= bindec($ba[4]) - 1) {
	$ha = "<div style=\"padding:0.5em;font-size:120%;display:flex;flex-wrap:wrap;align-items:flex-end;\"><div><b>" . $from . '</b>～<br /><b>' . $to . "</b></div> <div> (" . number_format($ips -2) . "個)</div></div>";
} else {
	$ha = "なし";
}
$ha_str = str_replace('cont', $ha, $ha_str);
//$ha_str = str_replace('comment', '', $ha_str);
$ha_str = preg_replace('|<div[^>]+><div[^>]+>comment</div></div>|', '', $ha_str);

$html .= $ha_str;
//$html .= "</div>\n";
$html .= "</form>\n";
$html .= "</div>";
$html .= "<div style=\"padding:0.5em;\">IPアドレスとサブネットマスクの論理積が<b>開始アドレス</b>(ネットワークアドレス)、\n";
$html .= "IPアドレスとサブネットマスクのビット反転の論理和が<b>終了アドレス</b>(ブロードキャストアドレス)ということになります。</div>\n";

$html = indent_div($html);
print $html;



function sanitize($string) {
	$string = str_replace('&','&amp;',$string);
	$string = str_replace('<','&lt;',$string);
	$string = str_replace('>','&gt;',$string);
	$string = str_replace('"','&quot;',$string);
	return($string);
}

function redirect($jump) {
	$bt = debug_backtrace();
	$line = $bt[0]['line'];
	$function = $bt[0]['function'];
	txt("{$line}行からredirectを呼び出し<>$function");
	header("Location: $jump", true, 301); exit(); 
}

function req($key) {
	if (isset($_REQUEST[$key])) {
		$req = $_REQUEST[$key];
	} else {
		$req = '';
	}
	return $req;
}



function error($mes) {
	head();
	print "<h2>エラー</h2>";
	print "<div>$mes</div>";
	footer();
	exit();
}



function indent_div($html) {
	//$html = preg_replace('/\r\n?/', "\n", $html);
	$html = str_replace(array("\r\n", "\r"), "\n", $html);
	$list = explode("\n", $html);
	$new_list = array();
	foreach ($list as $line) {
		if (!$line) { continue; }
		$div_pos = strpos($line, '<div', 1);
		while ($div_pos > 0) {
			$div_pos = strpos($line, '<div', 1);
			$str1 = substr($line, 0, $div_pos);
			$line = substr($line, $div_pos);
			$new_list[] = $str1;
		}
		if ($line) {
			$new_list[] = $line;
		}
	}
	$list = $new_list;
	$new_list = array();
	foreach ($list as $line) {
		if (!$line) { continue; }
		$div_pos = strpos($line, '</div', 1);
		while ($div_pos > 0) {
			$div_pos = strpos($line, '</div', 1);
			$str1 = substr($line, 0, $div_pos);
			$line = substr($line, $div_pos);
			$new_list[] = $str1;
		}
		if ($line) {
			$new_list[] = $line;
		}
	}
	$div_lev = 0;
	$list = $new_list;
	$new_list = array();
	foreach ($list as $line) {
		$div_plus = $div_minus = 0;
		$div_plus = substr_count($line, '<div');
		$div_minus = substr_count($line, '</div');
		if ($div_lev > 0 && preg_match('/^</', $line)) {
			if (preg_match('/^<\/div/', $line)) {
				$tab = str_repeat("\t", $div_lev - 1);
			} else {
				$tab = str_repeat("\t", $div_lev);
			}
		} else {
			$tab = '';
		}
		$new_list[] = $tab . $line;
		$div_lev = $div_lev + $div_plus - $div_minus;
	}
	return(join("\n", $new_list) . "\n");
}
?>
</div>
</body>
</html>
